---
title: WindowClient.focus()
slug: Web/API/WindowClient/focus
tags:
  - API
  - Client
  - Experimental
  - Focus
  - Method
  - Reference
  - Service Workers
  - WindowClient
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <strong><code>focus()</code></strong> method of the {{domxref("WindowClient")}} interface gives user input focus to the current client and returns a {{jsxref("Promise")}} that resolves<span> to the existing {{domxref("WindowClient")}}.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>windowClient</em>.focus().then(function(<em>windowClient</em>) {
  // do something with your WindowClient once it has been focused
});</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to the existing {{domxref("WindowClient")}}.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">self.addEventListener('notificationclick', function(event) {
  console.log('On notification click: ', event.notification.tag);
  event.notification.close();

  // This looks to see if the current is already open and
  // focuses if it is
  event.waitUntil(clients.matchAll({
    type: "window"
  }).then(function(clientList) {
    for (var i = 0; i &lt; clientList.length; i++) {
      var client = clientList[i];
      if (client.url == '/' &amp;&amp; 'focus' in client)
        return client.focus();
    }
    if (clients.openWindow)
      return clients.openWindow('/');
  }));
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-windowclient-focus', 'focus()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WindowClient.focus")}}</p>
</div>
